<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: import.php 2011-04-12 05:17:53 svn $
 * @author MADEBYPLAY
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');
jimport('joomla.filesystem.file');

// Include Slideshow table
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class Cu3erModelImport extends JModel {


	var $xml = array();
	var $slideshow_id;

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct() {
		parent::__construct();
	}    	

	/**
	 * Empty slideshow creator method (for getting slideshow_id)
	 *
	 * @access	public	
	 */
	function createEmptySlideshow() {
		$db = & JFactory::getDBO();

		$db->setQuery('INSERT INTO #__cu3er__slideshows SET name = 0');
		$db->query();

		// setting slideshow property according to the last inserted slideshow
		$this->slideshow_id = $db->insertid();
	}

	/**
	 * Slideshow database loader method
	 *
	 * @access	public	
	 * @param	object $cu3er_xml	Cu3erXML object of CU3ER config values
	 * @param	string $slideshow_name	Name of the CU3ER Slideshow
	 */
	function XMLArray2DB($cu3er_xml, $slideshow_name, $redirect = true) {

		$mainframe = &JFactory::getApplication();
		
		// basic redirection link
		$link = 'index.php?option=com_cu3er&view=import&importtype=' . JRequest::getVar('importtype', 'file');

		$db = & JFactory::getDBO();
		
		// slideshow id from the empty slideshow
		$slideshow_id = &$this->slideshow_id;

		// getting table instances
		$ss_tbl = & JTable::getInstance('Cu3erSlideshow', 'Table');
		$def_tbl = & JTable::getInstance('Cu3erDefault', 'Table');
		$sl_tbl = & JTable::getInstance('Cu3erSlide', 'Table');

		$ss_tbl->load($slideshow_id);
		$ss_tbl->name = $slideshow_name;

		// binding, checking and storing slideshow data		
		if (!$ss_tbl->bind($cu3er_xml->db_array['slideshows']) || !$ss_tbl->check() || !$ss_tbl->store()) {
			// redirecting with error message
			$mainframe->redirect($link, $ss_tbl->getError(), 'error');
		}

		$config =& JComponentHelper::getParams('com_media');

		$ss_tbl->load($slideshow_id);

		// setting Joomla dependent slideshow data
		$ss_tbl->images_folder = JURI::root().($config->get('image_path', 'images/stories')).DS.'CU3ER'.DS.$slideshow_id;
		$ss_tbl->fonts_folder = JURI::root().'components'.DS.'com_cu3er'.DS.'slideshows'.DS.$slideshow_id.DS.'fonts';
		$ss_tbl->xml_location = JURI::root().'components'.DS.'com_cu3er'.DS.'slideshows'.DS.$slideshow_id.DS.$ss_tbl->xml_location;

		// storing new data		
		if (!$ss_tbl->check() || !$ss_tbl->store()) {
			
			$this->deleteRecord('slideshows', $slideshow_id, 'id');
			$mainframe->redirect($link, $def_tbl->getError(), 'error');
		}

		$ss_tbl->checkin();

		// binding, checking and storing slide default data		
		if (!$def_tbl->bind($cu3er_xml->db_array['defaults']) || !$def_tbl->check() || !$def_tbl->store()) {
			// removing newly inserted slideshow entry if there is any error			
			$this->deleteRecord('slideshows', $slideshow_id, 'id');
			// redirecting with error message			
			$mainframe->redirect($link, $def_tbl->getError(), 'error');
		}

		// updating slideshow id to the proper one
		$slid_query = "UPDATE #__cu3er__defaults SET slideshow_id = {$slideshow_id} WHERE slideshow_id = 0";
		$db->setQuery($slid_query);
		$db->query();

	        $def_tbl->checkin();

		foreach($cu3er_xml->db_array['slides'] as $key => $slide) {

			// setting slideshow id of a slide db entry			
			$cu3er_xml->db_array['slides'][$key]['slideshow_id'] = $slideshow_id;

			// binding, checking and storing slide data	
			if (!$sl_tbl->bind($cu3er_xml->db_array['slides'][$key]) || !$sl_tbl->check() || !$sl_tbl->store()) {

				// removing every slideshow, default, slide entries with the given slideshow_id, if there is any error
				$this->deleteRecord('slideshows', $slideshow_id, 'id');
				$this->deleteRecord('defaults', $slideshow_id);
				$this->deleteRecord('slides', $slideshow_id);

				$mainframe->redirect($link, $sl_tbl->getError(), 'error');

			}
			
			$sl_tbl->reset();
		}

		// successfull slideshow import message
		$msg = 'CU3ER Slideshow imported successfully';

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'lib'.DS.'cu3erfile.class.php');
		
		// generating CU3ER-generated.xml file according to the database values
		if (!Cu3erFile::generateXMLFile($slideshow_id)) {
			$msg = 'Unable to write CU3ER-generated.xml file';		
		}

		// cleaning up cache
	        $cache = &JFactory::getCache('com_cu3er');
	        $cache->clean();

		if($redirect) {
			// calling page redirection
			$mainframe->redirect('index.php?option=com_cu3er&view=slideshows', JText::_($msg));
		} else {
			die('Project successfully imported!');
		}

	}

	/**
	 * Slideshow package (XML, images, fonts) processor method (handling unzip, validating XML)
	 *
	 * @access	public	
	 * @param	string	$slideshow_name name of CU3ER slideshow
	 * @return	string	path of the CU3ER-config.xml file
	 */
	function prepareCu3erFiles($slideshow_name) {

		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erxml.class.php');	
		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php');

		$slideshow_id = &$this->slideshow_id;
	
		$mainframe = &JFactory::getApplication();

		// setting CU3ER package file properties
		$importtype = (JRequest::getVar('importtype') != '') ? JRequest::getVar('importtype') : 'file';
		$filepath = JRequest::getVar('filepath');
		$pathinfo = pathinfo($filepath);

		// basic redirection link
		$link = 'index.php?option=com_cu3er&view=import&name='.$slideshow_name.'&importtype='.$importtype;
		$error = 'error';
		$xml_file = null;
		$msg = null;

		$slideshow_dir = JPATH_COMPONENT_SITE.DS.'slideshows'.DS.$slideshow_id;
	
		$slideshow_img_dir = JPATH_SITE.DS.(JComponentHelper::getParams('com_media')->get('image_path')).DS.'CU3ER'.DS.$slideshow_id;

		if ($this->slideshowExists($slideshow_name)) {	
			$msg = 'Slideshow with the given name already exists!';
		} elseif (JFolder::exists($slideshow_dir)) {
			$msg = 'Slideshow folder with the given name exists in /components/com_cu3er/slideshows!';
		} elseif (!JFolder::create($slideshow_dir)) {
			$msg = 'Unable to create slideshow folder in /components/com_cu3er/slideshows!';
		}

		// handling CU3ER package files
		if ($importtype == 'file' && $msg == null) {

			jimport('joomla.filesystem.folder');

			// if package file is not uploaded yet			
			if (JRequest::getInt('state') == 0) {
				$msg = 'You must upload CU3ER file (xml/zip) before you save slideshow!';
			// if package file is zipped			
			} elseif ($pathinfo['extension'] == 'zip') {

				jimport('joomla.filesystem.archive'); 				

				// extracting zip file
				if (!JArchive::extract($filepath, $pathinfo['dirname'])) {
					$msg = 'Unable to extract zip file!';
				} 				

				if (!JFile::exists($pathinfo['dirname'].DS.'CU3ER-config.xml')) {
					$xmlName = glob($pathinfo['dirname'].DS.'*.xml');
				} else {
					$xmlName[0] = 'CU3ER-config.xml';
				}
				if($xmlName[0] != '') {
					$xml_file = $pathinfo['dirname'].DS.basename($xmlName[0]);
					if (	!JFolder::move($pathinfo['dirname'].DS.'images', $slideshow_img_dir) ||
						!JFolder::move($pathinfo['dirname'].DS.'fonts', $slideshow_dir.DS.'fonts')) {
						$msg = 'Unable to copy slideshow subfolders (images, fonts) to /components/com_cu3er/slideshows/[slideshow name]!';
					}
				} else {
					$msg = 'COULD NOT LOCATE XML FILE_ CHECK IF XML FILE EXIST, OR IF IT IS READABLE TO SCRIPT';
				}
			// if file is a standalone XML file			
			} elseif ($pathinfo['extension'] == 'xml') {
				$xml_file = $filepath;
			}
		}

		// handling remote CU3ER XML files
		if ($importtype == 'url' && $msg == null) {		

			$url = JRequest::getVar('url');		
			$status = Cu3erFile::lookup($url); 

			/*if(!$status) { 
				$msg = 'Failed to connect to website!';
			} elseif ($status[0] >= 400) { 
				$msg = 'File does not exist on that website or is not accessible!';
			} else {*/
				$xml_file = $url;	
			//}
		}

		// validating XML file
		if (!is_null($xml_file) && !Cu3erXML::isXML($xml_file)) {
			 
			$msg = 'CU3ER config file is not a well formed XML file!';		
		
		} elseif (!is_null($xml_file)) {
			
			$msg_xml = 'Unable to copy CU3ER config XML file to /components/com_cu3er/slideshows/[slideshow id]!';
			$msg_html = 'Unable to copy embed_example.html file to /components/com_cu3er/slideshows/[slideshow id]!';			

			if ($importtype == 'url') {

				if (!Cu3erFile::saveRemoteFile($xml_file, $slideshow_dir.DS.basename($xml_file))) {
					$msg = $msg_xml;
				} else {
					$error = false;		
				}				

			} else {			
				// moving CU3ER-config.xml file to the slideshows folder of the component's frontend
				if (!JFile::move($xml_file, $slideshow_dir.DS.basename($xml_file))) {
					$msg = $msg_xml;
				// moving embed_example.html file to the slideshows folder of the component's frontend
				} elseif (!JFile::move($pathinfo['dirname'].DS.'embed_example.html', $slideshow_dir.DS.'embed_example.html')) {
					$msg = $msg_html;
				} else {
					// moving CU3ER flash movie and embedder javascript file to the proper folders of frontend
					if (JFile::exists($pathinfo['dirname'].DS.'CU3ER.swf') && !JFile::exists(JPATH_COMPONENT_SITE.DS.'flash'.DS.'CU3ER.swf')) {
						if (!JFile::move($pathinfo['dirname'].DS.'CU3ER.swf', JPATH_COMPONENT_SITE.DS.'flash'.DS.'CU3ER.swf')) {
							$msg = 'Unable to copy CU3ER_swf file to /components/com_cu3er/flash!';						
						}				
					}

					if (JFile::exists($pathinfo['dirname'].DS.'js'.DS.'jquery.cu3er.player.js') && !JFile::exists(JPATH_COMPONENT_SITE.DS.'js'.DS.'jquery.cu3er.player.js')) {
						if (!JFile::move($pathinfo['dirname'].DS.'jquery.cu3er.player.js', JPATH_COMPONENT_SITE.DS.'js'.DS.'jquery.cu3er.player.js')) {
							$msg = 'Unable to copy jquery_cu3er_player_js file to /components/com_cu3er/js!';						
						}
					}

					require_once(JPATH_COMPONENT.DS.'helpers'.DS.'cu3er_files.php');

					if (!JFile::exists(JPATH_COMPONENT_SITE.DS.'js'.DS.'jquery.player.js') && !Cu3erFile::saveRemoteFile($remote_url.DS.$files['jquery.cu3er.js']['url_subdir'].DS.'jquery.cu3er.js', JPATH_COMPONENT_SITE.DS.'js'.DS.'jquery.cu3er.js')) {
							$msg = 'Unable to download jquery_cu3er_js file from the CU3ER server!';						
					} else {					
						$error = false;
					}
				}
			}
		}

		// cleaning up upload folder from temporary files		
		if ($importtype != 'url') {
			Cu3erFile::deleteAll(JPATH_COMPONENT_ADMINISTRATOR.DS.'upload', true);
		}

		// handling errors		
		if ($error) {
			if (JFolder::exists($slideshow_dir) && strlen($slideshow_name) > 0) {			
				// cleaning up database and folders from trash				
				Cu3erFile::deleteAll($slideshow_dir);
				$this->deleteRecord('slideshows', $slideshow_id, 'id');		
			}
			$mainframe->redirect($link, JText::_($msg), $error);
		} else {
			return $slideshow_dir.DS.basename($xml_file);		
		}
	}
	
	function prepareCu3erFilesImport($slideshow_name, $filepath) {

		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erxml.class.php');	
		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php');

		$slideshow_id = &$this->slideshow_id;
	
		$mainframe = &JFactory::getApplication();

		// setting CU3ER package file properties
		$pathinfo = pathinfo($filepath);

		// basic redirection link
		$link = 'index.php?option=com_cu3er&view=import&name='.$slideshow_name.'&importtype=file';
		$error = 'error';
		$xml_file = null;
		$msg = null;

		$slideshow_dir = JPATH_COMPONENT_SITE.DS.'slideshows'.DS.$slideshow_id;
	
		$slideshow_img_dir = JPATH_SITE.DS.(JComponentHelper::getParams('com_media')->get('image_path')).DS.'CU3ER'.DS.$slideshow_id;

		if ($this->slideshowExists($slideshow_name)) {	
			$msg = 'Slideshow with the given name already exists!';
		} elseif (JFolder::exists($slideshow_dir)) {
			$msg = 'Slideshow folder with the given name exists in /components/com_cu3er/slideshows!';
		} elseif (!JFolder::create($slideshow_dir)) {
			$msg = 'Unable to create slideshow folder in /components/com_cu3er/slideshows!';
		}

		// handling CU3ER package files
		if ($msg == null) {

			jimport('joomla.filesystem.folder');

			// if package file is not uploaded yet			
			if ($pathinfo['extension'] == 'zip') {

				jimport('joomla.filesystem.archive'); 				

				// extracting zip file
				if (!JArchive::extract($filepath, $pathinfo['dirname'])) {
					$msg = 'Unable to extract zip file!';
				} 				

				if (!JFile::exists($pathinfo['dirname'].DS.'CU3ER-config.xml')) {
					$xmlName = glob($pathinfo['dirname'].DS.'*.xml');
				} else {
					$xmlName[0] = 'CU3ER-config.xml';
				}
				if($xmlName[0] != '') {
					$xml_file = $pathinfo['dirname'].DS.basename($xmlName[0]);
					if (	!JFolder::move($pathinfo['dirname'].DS.'images', $slideshow_img_dir) ||
						!JFolder::move($pathinfo['dirname'].DS.'fonts', $slideshow_dir.DS.'fonts')) {
						$msg = 'Unable to copy slideshow subfolders (images, fonts) to /components/com_cu3er/slideshows/[slideshow name]!';
					}
				} else {
					$msg = 'COULD NOT LOCATE XML FILE_ CHECK IF XML FILE EXIST, OR IF IT IS READABLE TO SCRIPT';
				}
			// if file is a standalone XML file			
			} elseif ($pathinfo['extension'] == 'xml') {
				$xml_file = $filepath;
			}
		}

		// validating XML file
		if (!is_null($xml_file) && !Cu3erXML::isXML($xml_file)) {
			 
			$msg = 'CU3ER config file is not a well formed XML file!';		
		
		} elseif (!is_null($xml_file)) {
			
			$msg_xml = 'Unable to copy CU3ER config XML file to /components/com_cu3er/slideshows/[slideshow id]!';
			$msg_html = 'Unable to copy embed_example.html file to /components/com_cu3er/slideshows/[slideshow id]!';			

			// moving CU3ER-config.xml file to the slideshows folder of the component's frontend
			if (!JFile::move($xml_file, $slideshow_dir.DS.basename($xml_file))) {
				$msg = $msg_xml;
			// moving embed_example.html file to the slideshows folder of the component's frontend
			} elseif (!JFile::move($pathinfo['dirname'].DS.'embed_example.html', $slideshow_dir.DS.'embed_example.html')) {
				$msg = $msg_html;
			} else {
				// moving CU3ER flash movie and embedder javascript file to the proper folders of frontend
				if (JFile::exists($pathinfo['dirname'].DS.'CU3ER.swf') && !JFile::exists(JPATH_COMPONENT_SITE.DS.'flash'.DS.'CU3ER.swf')) {
					if (!JFile::move($pathinfo['dirname'].DS.'CU3ER.swf', JPATH_COMPONENT_SITE.DS.'flash'.DS.'CU3ER.swf')) {
						$msg = 'Unable to copy CU3ER_swf file to /components/com_cu3er/flash!';						
					}				
				}

				if (JFile::exists($pathinfo['dirname'].DS.'js'.DS.'jquery.cu3er.player.js') && !JFile::exists(JPATH_COMPONENT_SITE.DS.'js'.DS.'jquery.cu3er.player.js')) {
					if (!JFile::move($pathinfo['dirname'].DS.'jquery.cu3er.player.js', JPATH_COMPONENT_SITE.DS.'js'.DS.'jquery.cu3er.player.js')) {
						$msg = 'Unable to copy jquery_cu3er_player_js file to /components/com_cu3er/js!';						
					}
				}

				require_once(JPATH_COMPONENT.DS.'helpers'.DS.'cu3er_files.php');

				if (!JFile::exists(JPATH_COMPONENT_SITE.DS.'js'.DS.'jquery.player.js') && !Cu3erFile::saveRemoteFile($remote_url.DS.$files['jquery.cu3er.js']['url_subdir'].DS.'jquery.cu3er.js', JPATH_COMPONENT_SITE.DS.'js'.DS.'jquery.cu3er.js')) {
						$msg = 'Unable to download jquery_cu3er_js file from the CU3ER server!';						
				} else {					
					$error = false;
				}
			}
		}

		// cleaning up upload folder from temporary files
		Cu3erFile::deleteAll(JPATH_COMPONENT_ADMINISTRATOR.DS.'upload', true);

		// handling errors		
		if ($error) {
			if (JFolder::exists($slideshow_dir) && strlen($slideshow_name) > 0) {			
				// cleaning up database and folders from trash				
				Cu3erFile::deleteAll($slideshow_dir);
				$this->deleteRecord('slideshows', $slideshow_id, 'id');		
			}
			$mainframe->redirect($link, JText::_($msg), $error);
		} else {
			return $slideshow_dir.DS.basename($xml_file);		
		}
	}

	/**
	 * Table record removal method
	 *
	 * @access	public	
	 * @param	string	$tbl Table name
	 * @param	int	$int ID of the record
	 * @param	string	$key Primary key of the table
	 */
	function deleteRecord($tbl, $id, $key = 'slideshow_id') {
		
		$db = & JFactory::getDBO();
		$slideshow_id = $db->insertid();

		$query = "DELETE FROM #__cu3er__{$tbl} " .	
			 "WHERE {$key} = {$id}";
		
		$db->setQuery($query);
		$db->query();	
	}

	/**
	 * Slideshow file upload handler method
	 *
	 * @access	public	
	 */
	function upload() {

		require_once JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php';

		$return	= 'index.php?option=com_cu3er&view=import&importtype=file&name='.JRequest::getVar('name');
		Cu3erFile::uploadFile($return, 'zip,xml', true);
	}

	/**
	 * Slideshow existance checker method
	 *
	 * @access	public
	 * @return 	int ID of existing slideshow	
	 */
	function slideshowExists($slideshow_name) {
		$db = & JFactory::getDBO();
		$name = strtolower($slideshow_name);
		$db->setQuery("SELECT id FROM #__cu3er__slideshows WHERE LOWER(name) = '{$name}'");
		return ($db->loadResult());
	}

}
