<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: view.html.php 2011-04-12 05:17:53 svn $
 * @author MADEBYPLAY
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport( 'joomla.application.component.view');

// Import CU3ER helper
jimport('joomla.application.component.helper');

class Cu3erViewSlide extends JView {

	// variables for Cu3erHelper helper class	
	var $num = 0;
	var $slideshow_id = null;

	function display($tpl = null) {
		
		$model = & $this->getModel();

		// adding mootools.js to the HTML header
		JHTML::_('behavior.mootools');	

		// setting if the slide is new
		$empty = (JRequest::getInt('empty'))?1:0;

		// setting JTable instances of slideshow, default and slide		
		$slide = $model->getData('Cu3erSlide', null, $empty);
		
		$slideshow_id = ($slide->slideshow_id)?$slide->slideshow_id:JRequest::getInt('slideshow_id');

		$default = $model->getData('Cu3erDefault', $slideshow_id);
		$slideshow = $model->getData('Cu3erSlideshow', $slideshow_id);

		JFilterOutput::objectHTMLSafe($slide);

		// new slide is published by default		
		if(!$slide->id) {
			$slide->published = 1;
		}

		$this->slideshow_id = $slideshow_id;
		
		// setting up page title according to the slide (new/existing)		
		(JRequest::getInt('cid'))? $title = JText::_('Edit Slide &amp; Transition') : $title = JText::_('Add Slide &amp; Transition');

		// setting up toolbar buttons (at the right)
		JToolBarHelper::title($title);
		JToolBarHelper::save();
		JToolBarHelper::custom('saveAndNew','save.png','save_f2.png', JText::_('Save &amp; New'), false);
		JToolBarHelper::apply();
		$hasJS = $model->hasJavaScript($slideshow->images_folder);
		if($slide->id) {
			$bar=& JToolBar::getInstance('toolbar');
			$bar->appendButton('Popup', 'preview', JText::_('Preview'), '../index.php?option=com_cu3er&view=slideshow&tmpl=component&preview=1&cid='.$slideshow_id, $slideshow->width, $slideshow->height);
			if($hasJS) {
				$bar->appendButton('Popup', 'preview', JText::_('Preview JS'), '../index.php?option=com_cu3er&view=slideshow&tmpl=component&preview=2&cid='.$slideshow_id, $slideshow->width, $slideshow->height);
			}
			/*JToolBarHelper::custom('preview', 'preview.png','preview_f2.png', JText::_('Preview'), false);
			if($model->hasJavaScript($slideshow->images_folder)) {
				JToolBarHelper::custom('preview_js', 'preview.png','preview_f2.png', JText::_('Preview JS'), false);
			}*/
		}
		JToolBarHelper::custom('slidedefault', 'default.png','default_f2.png', JText::_('Slide Defaults'), false);
		JToolBarHelper::custom('slideshowSettings', 'config.png','config_f2.png', JText::_('Slideshow Settings'), false);
		JToolBarHelper::cancel();

		// setting up submenu
		JSubMenuHelper::addEntry(JText::_('Slideshows'), 'index.php?option=com_cu3er&view=slideshows');		
		JSubMenuHelper::addEntry(JText::_('Slideshow Settings'), 'index.php?option=com_cu3er&view=slideshow&cid=' . $slideshow_id);
		JSubMenuHelper::addEntry(JText::_('Slide Defaults'), 'index.php?option=com_cu3er&view=slidedefault&cid=' . $slideshow_id);
		JSubMenuHelper::addEntry(JText::_('Slides &amp; Transitions'), 'index.php?option=com_cu3er&view=slides&cid=' . $slideshow_id);
		
		require_once(JPATH_COMPONENT.DS.'helpers'.DS.'slide_fields.php');

		// assigning variables to the template (tmpl/default.php)
		$var = ($hasJS == true) ? 'true' : 'false';
		$this->assignRef('ajax_data', $model->generateJSON($slide, $default));
		$this->assignRef('slideshow_id', $slideshow_id);
		$this->assignRef('slide_params', $slide);
		$this->assignRef('defaults', $default);
		$this->assignRef('hidden_fields', $hidden_fields);
		$this->assignRef('special_fields', $special_fields_slide);
		$this->assignRef('field_groups', $field_groups);
		$this->assignRef('has_js', $var);

		// SqueezeBox initializator script		
		$js_str = <<<EOD
		
		window.addEvent('domready', function() {			

			SqueezeBox.initialize({ size: {x: {$slideshow->width}, y: {$slideshow->height}}});

			SqueezeBox.addEvent('onClose', function() {
				
				if($('task').value == 'preview_js') {				
					// fallback image restoring ajax call					
					var ar = new Ajax('index.php?option=com_cu3er&view=slide&task=restoreslide&tmpl=component', 
						{
							method: 'post',
							data: {
								'slideshow_id':$('slideshow_id').value,
							},

							onSuccess: function(resp) {
								eval('resp='+resp);					
								// displaying possible error message from the PHP response					
								if (resp.success != 1) {					
									alert(resp.error);								
								}							
							},
						}).request();
				}
			});
			
		});
EOD;
		$doc =& JFactory::getDocument();

		// adding SqueezeBox initializator script to the HTML head		
		$doc->addScriptDeclaration($js_str);

		// adding misc.js (miscellaneous functions) to the HTML head
		$doc->addScript(JURI::base().'components'.DS.'com_cu3er'.DS.'js'.DS.'misc.js');

		parent::display($tpl);
	}
}
?>